package com.goats.utils;

import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.node.ObjectNode;

import java.io.IOException;

/**
 * 合并json串方法
 */
public class MergeJson {


    public static void main(String[] args) {
        // 示例多个JSON字符串
        String jsonString1 = "{ \"DeviceID\": \"1016\", \"seq\": \"12345\", \"Date\": \"2025-02-11\", \"A049\": 12121122.1, \"A050\": 12121122.11 }";
        String jsonString2 = "{ \"DeviceID\": \"1016\", \"seq\": \"67890\", \"Date\": \"2025-02-12\", \"A051\": 12121122.11, \"A052\": 12121122.11 }";
        String jsonString3 = "{ \"DeviceID\": \"1016\", \"seq\": \"98765\", \"Date\": \"2025-02-13\", \"A053\": 12121122.22, \"A054\": 12121122.33 }";

    }

    /**
     * 合并多个json串
     * @param jsonStrings
     * @return
     * @throws IOException
     */
    public static String mergeJsonStrings2(String... jsonStrings) throws IOException {
        // 创建 ObjectMapper 实例
        ObjectMapper mapper = new ObjectMapper();

        // 创建一个空的 ObjectNode 来存放合并后的内容
        ObjectNode mergedNode = mapper.createObjectNode();

        // 遍历传入的所有 JSON 字符串
        for (String jsonString : jsonStrings) {
            // 解析当前 JSON 字符串为 JsonNode
            JsonNode jsonNode = mapper.readTree(jsonString);

            // 合并字段
            jsonNode.fieldNames().forEachRemaining(fieldName -> {
                // 忽略重复的字段 seq, Date 和 DeviceID，只保留一个
                if (!fieldName.equals("seq") && !fieldName.equals("Date")) {
                    mergedNode.set(fieldName, jsonNode.get(fieldName));
                }
            });
        }

        // 返回合并后的 JSON 字符串
        return mapper.writerWithDefaultPrettyPrinter().writeValueAsString(mergedNode);
    }
}
